This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 226715 - Review Request: irsim - Switch-level simulator
Review Request: irsim - Switch-level simulator
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mamoru TASAKA
Fedora Package Reviews List
:
Depends On:
Blocks: FE-ACCEPT
  Show dependency treegraph
 
Reported: 2007-01-31 23:54 EST by Chitlesh GOORAH
Modified: 2008-12-28 14:23 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-02-05 18:06:41 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
kevin: fedora‑cvs+


Attachments (Terms of Use)
Mock build log of irsim-9.7.41-1.fc7 (89.98 KB, text/plain)
2007-02-01 02:21 EST, Mamoru TASAKA
no flags Details
irsim -2.1 spec file I created (1.95 KB, text/plain)
2007-02-01 09:27 EST, Mamoru TASAKA
no flags Details
tut_irsim_gate.sim (373 bytes, text/plain)
2007-02-04 14:40 EST, Chitlesh GOORAH
no flags Details
tut_irsim_scmos2um.prm (3.42 KB, text/plain)
2007-02-04 14:41 EST, Chitlesh GOORAH
no flags Details
example.cmd (212 bytes, text/plain)
2007-02-04 14:41 EST, Chitlesh GOORAH
no flags Details
screenshot (371.85 KB, image/png)
2007-02-04 14:42 EST, Chitlesh GOORAH
no flags Details
c.ps (2.85 KB, application/postscript)
2007-02-04 14:43 EST, Chitlesh GOORAH
no flags Details
corrected screenshot (330.70 KB, image/png)
2007-02-04 15:19 EST, Chitlesh GOORAH
no flags Details
irsim -3.1 spec file I created (2.42 KB, text/plain)
2007-02-05 10:55 EST, Mamoru TASAKA
no flags Details

  None (edit)
Description Chitlesh GOORAH 2007-01-31 23:54:27 EST
Spec URL: http://tux.u-strasbg.fr/~chit/RPMS/irsim.spec
SRPM URL: http://tux.u-strasbg.fr/~chit/RPMS/irsim-9.7.41-1.src.rpm
Description:
IRSIM is a tool for simulating digital circuits. It is a "switch-level"
simulator; that is, it treats transistors as ideal switches. Extracted
capacitance and lumped resistance values are used to make the switch a little
bit more realistic than the ideal, using the RC time constants to predict the
relative timing of events.
Comment 1 Mamoru TASAKA 2007-02-01 02:21:37 EST
Created attachment 147073 [details]
Mock build log of  irsim-9.7.41-1.fc7

Only tried to rebuild this: not checked for
packaging issue.

Mock build log of  irsim-9.7.41-1 on FC-devel i386.
Fedora specific compilation flags are not passed.
Please check how CFLAGS etc are dealt.
Comment 2 Chitlesh GOORAH 2007-02-01 03:12:55 EST
Updated:
Spec URL: http://tux.u-strasbg.fr/~chit/RPMS/irsim.spec
SRPM URL: http://tux.u-strasbg.fr/~chit/RPMS/irsim-9.7.41-1.src.rpm

Then, magic too suffers from that missing CFLAGS. I'll work on it.
Comment 3 Chitlesh GOORAH 2007-02-01 03:16:48 EST
typo:
SRPM URL: http://tux.u-strasbg.fr/~chit/RPMS/irsim-9.7.41-2.src.rpm
Comment 4 Mamoru TASAKA 2007-02-01 07:05:10 EST
Well, I want to check -2 today (in Japan, EST+14h),
however rawhide upgraded tk related packages and
please wait until upgrading ends successfully.
Comment 5 Mamoru TASAKA 2007-02-01 07:10:39 EST
Umm.. rawhide report says that currently several
packages have broken dependency against tk as
tk is upgraded to 8.5, so first I have to rebuild
all broken packages locally against new tk first...
Comment 6 Mamoru TASAKA 2007-02-01 09:27:53 EST
Created attachment 147103 [details]
irsim -2.1 spec file I created

Well:

* Source tarball includes unneeded symlink. Your
  original spec file does not remove this symlink
  on %clean stage.
* Passing cflags can be done in more easy way.
  And the manual modification against files 
  automatically created by configure should be avoided
  when possible.
* Timestamps are not kept

My spec file should hopefully fix them. Please check
it.
I will check if another issues are left to be fixed.
Comment 7 Mamoru TASAKA 2007-02-01 11:07:31 EST
Well, for -2.1:

* License:
  I doubt that this is licensed under GPL.
  All texts which include explicit license terms
  refer to the same sentences, however, I just
  don't know how this license is called...
  Please check:
  ./analyzer/anXhelper.c for example.
  (Note: license for files created by autotools
   should be ignored).

* Some documentation
  I wonder if the 3 documentation
-----------------------------------------
/usr/lib/irsim/doc/irsim-analyzer.doc
/usr/lib/irsim/doc/irsim.doc
/usr/lib/irsim/doc/netchange.doc
-----------------------------------------
  are really needed because:
  * they are the same as man pages installed.
  * it seems that they are not used at runtime.

? Would you give me some examples so that
  I can check if this program works well?

? I just wonder if the following compilation flag is
  proper:
---------------------------------
DPACKAGE_BUGREPORT=\"magic-hackers@csl.cornell.edu\"
---------------------------------
  Should this be your mail address?

? By the way, what are the files under other/
  directory?
Comment 8 Chitlesh GOORAH 2007-02-03 06:06:26 EST
(In reply to comment #7)
> Well, for -2.1:
> 
> * License:
>   I doubt that this is licensed under GPL.
>   All texts which include explicit license terms
>   refer to the same sentences, however, I just
>   don't know how this license is called...
>   Please check:
>   ./analyzer/anXhelper.c for example.
>   (Note: license for files created by autotools
>    should be ignored).
> 

under scripts/irsim.spec.in you will see GPL. However, I've asked upstream for
more clarity on this. Here is what he answered:
-------------
The only copyright notices that appear are in the C code itself.
For a typical example (they're all the same as far as I saw):
/base/rsim.c has the following copyright notice:

*********************************************************************
* Copyright (C) 1988, 1990 Stanford University.                     *
* Permission to use, copy, modify, and distribute this              *
* software and its documentation for any purpose and without        *
* fee is hereby granted, provided that the above copyright          *
* notice appear in all copies.  Stanford University                 *
* makes no representations about the suitability of this            *
* software for any purpose.  It is provided "as is" without         *
* express or implied warranty.  Export of this software outside     *
* of the United States of America may require an export license.    *
*********************************************************************

From my meager understanding of software copyright law, the fact that
the Stanford copyright is less restrictive than GPL means that the GPL
license may be applied to the package without any problem.  I can add
the standard GPL copyright notice to the distribution, if you would
like.

                    Regards,
                    Tim 
------

So eventually, I asked him to add the GPL notice to the package.

> * Some documentation
>   I wonder if the 3 documentation
> -----------------------------------------
> /usr/lib/irsim/doc/irsim-analyzer.doc
> /usr/lib/irsim/doc/irsim.doc
> /usr/lib/irsim/doc/netchange.doc
> -----------------------------------------
>   are really needed because:
>   * they are the same as man pages installed.
>   * it seems that they are not used at runtime.
> 

You are right about it, I'll remove them.

> ? Would you give me some examples so that
>   I can check if this program works well?
> 
> ? I just wonder if the following compilation flag is
>   proper:
> ---------------------------------
> DPACKAGE_BUGREPORT=\"magic-hackers@csl.cornell.edu\"
> ---------------------------------
>   Should this be your mail address?
> 

I'll point it to http://bugzilla.redhat.com

> ? By the way, what are the files under other/
>   directory?

Generally in this type of packages, they are contributed codes that 
- we don't know their license
- they are not currently maintained
- we don't know about their accuracy/precision on their methods
Comment 9 Chitlesh GOORAH 2007-02-04 14:40:14 EST
I struck a bug, which I'm working with upstream reveal its identify.

I think you should be aware of what it is (perhaps you might find something that
we can't see ):

irsim tut_irsim_scmos2um.prm tut_irsim_gate.sim -example.cmd

I can't see any changes on analyser however when I print the output to a
file, I can see evolution with respect to time.
see file c.ps

see screenshot

Comment 10 Chitlesh GOORAH 2007-02-04 14:40:48 EST
Created attachment 147317 [details]
tut_irsim_gate.sim
Comment 11 Chitlesh GOORAH 2007-02-04 14:41:22 EST
Created attachment 147318 [details]
tut_irsim_scmos2um.prm
Comment 12 Chitlesh GOORAH 2007-02-04 14:41:56 EST
Created attachment 147319 [details]
example.cmd
Comment 13 Chitlesh GOORAH 2007-02-04 14:42:44 EST
Created attachment 147320 [details]
screenshot
Comment 14 Chitlesh GOORAH 2007-02-04 14:43:15 EST
Created attachment 147321 [details]
c.ps
Comment 16 Chitlesh GOORAH 2007-02-04 15:16:17 EST
We know what the problem is : which in fact quite silly. :)

The display was being redrawn after all.  The problem is that the background is
being drawn white, and the traces are drawn white, so the result is
white-on-white, and invisible!

The Tcl/Tk version was hacked on top of the X11 version, and some things aren't
properly configured for Tcl/Tk.  In Magic and XCircuit, the X defaults has been
moved to Tcl, where they are read from a Tcl script.  In IRSIM, the properties
are still controlled by X11 and the X11 resource manager.

The white-on-white probably comes from a default .Xdefaults or possibly
.Xresources setting "*background: white" which makes all backgrounds white by
default. 

You can avoid this by adding to your home .Xdefaults file:

    irsim.background:  black

and then reloading with "xrdb -load .Xdefaults".
Comment 17 Chitlesh GOORAH 2007-02-04 15:19:28 EST
Created attachment 147327 [details]
corrected screenshot
Comment 18 Mamoru TASAKA 2007-02-05 10:55:54 EST
Created attachment 147364 [details]
irsim -3.1 spec file I created

A bit modified irsim.spec

I added some fixes for mainly two issues.
*
-------------------------------------------
%{__cp} -p doc/faultsim/fsim.ps %{buildroot}%{_docdir}/%{name}-%{version}
-------------------------------------------
  This is of no sense because %doc macro firstly clean
  %{_docdir}/%{name}-%{version} directory.

*
--------------------------------------------
%{__rm} -rf %{buildroot}%{_libdir}/%{name}/doc/
.......
%{__rm} -f
%{buildroot}%{_libdir}/%{name}/doc/{irsim,irsim-analyzer,netchange}.doc
--------------------------------------------
  The latter does nothing.

  I have not yet checked your example, however,
> You can avoid this by adding to your home .Xdefaults file:
> 
>     irsim.background:  black
> 
> and then reloading with "xrdb -load .Xdefaults".

  ... Can this be done automatically by adding some files in irsim
  rpm? If it cannot, adding some documentation may be kinder.
Comment 20 Mamoru TASAKA 2007-02-05 13:52:04 EST
Okay!!

----------------------------------------------------
  This package (irsim) is APPROVED by me.
Comment 21 Bill Nottingham 2007-02-05 17:05:48 EST
Package pre-import admin stuff done. Feel free to import.
Comment 22 Chitlesh GOORAH 2008-12-27 21:53:22 EST
Package Change Request
=======================
Package Name: irsim
Short Description: Switch-level simulator
Owners: chitlesh
Branches: EL-5
Comment 23 Kevin Fenzi 2008-12-28 14:23:13 EST
cvs done.

Note You need to log in before you can comment on or make changes to this bug.